#include <stdio.h>
#include <string.h>
#include <termios.h> 
#include <fcntl.h> 
#include <sys/stat.h> 
#include <sys/types.h>
static int set_com(int fd,int speed)
{
  struct termios jiang;
  jiang.c_cflag = 0x8b0 | speed;
  jiang.c_iflag = 1;
  jiang.c_lflag = 0x8040284;
  jiang.c_cc[VTIME] = 0;
  jiang.c_cc[VMIN]  = 0;
  tcflush(fd, TCIOFLUSH);           //clear buffer
  if(tcsetattr(fd, TCSANOW, &jiang)){perror("Failed to tcgetattr");return -1;}
  return 0;
}

int BAUD;

main() 
{ 
  int fd, i,j=0, k, itc=0; unsigned char bou[255],bin[255];
  FILE *fp;
  system("sudo chmod 777 /dev/ttyS0");
  fd = open("/dev/ttyS0", O_RDWR);
  if(fd <0 ){ perror("uart open err:"); return -1; }
  BAUD=9600;
  fp=fopen("/u/ccdev/jiang/BAUD","r");
  if(fp){ fscanf(fp,"%d",&BAUD); fclose(fp); }
  printf("BAUD: %d\n",BAUD);
  if(BAUD==2400)i=B2400;
  if(BAUD==4800)i=B4800;
  if(BAUD==9600)i=B9600;
  if(BAUD==19200)i=B19200;
  if(BAUD==38400)i=B38400;
  if(BAUD==57600)i=B57600;
  if(set_com(fd,i)){ printf("set_com failed!\n"); return -1; }

  while(1){
    sleep(1); itc++; itc&=3;
    if(itc==1){
      if(j==1)sprintf(bou,"movv 12:34:56.0 56:34:12\012");
      if(j==4)sprintf(bou,"filt g\012");   
      if(j==1 || j==4){
        write(fd, bou, strlen(bou));
        printf("S: %s",bou);
      }
      j++; j&=7;
    }
    if(itc==2){ bou[0]='`'; bou[1]=0; write(fd,bou,1); }
    k=read(fd,bin,255);
    if(k>0){ bin[k]=0;
      if(k>69){  
        if(bin[69]!='`'){ for(i=0;i<k-69;i++)bin[i]=bin[i+69];
                          k-=69; bin[k]=0; }
      }
      for(i=0;i<k;i++){
        if(bin[i]=='"')bin[i]='.';
        if(bin[i]=='\'')bin[i]=':';
        if(bin[i]==32)bin[i]='_';
        if(bin[i]=='=')bin[i]='0';
      }
      printf("R(%d): %s",k,bin);
    }
  }
}
